#ifndef __WENDU_H
#define __WENDU_H

#include "adc.h"
#include "stdio.h"
#include "math.h"
#include "Inf_4G.h"
#include "Driver.h"
#include  "EEPROM.h"

#define TEMP_LOWER_LIMIT_ADDR 0x70    // 温度下限存储地址
#define TEMP_UPPER_LIMIT_ADDR 0x74    // 温度上限存储地址
#define TEMP_FLAG_ADDR 0x78           // 温度标志地址
#define TEMP_FLAG_VAL 0xA6            // 温度标志值



extern uint16_t adc_value;
extern float voltage, temperature;
extern volatile float analog_status[3];  // 添加这行！
extern float temp_lower_limit;  // 默认下限温度15℃
extern float temp_upper_limit;  // 默认上限温度20℃
void Print_Temperature(uint16_t *data);
void Load_Temp_Limits_From_EEPROM(void);
#endif

