#include "Inf_4G.h"
// Irrigation.h򵥶config.hжЩ

// AT״̬
typedef enum
{
    AT_IDLE,
    AT_SENDING,
    AT_WAITING,
    AT_COMPLETE
} AT_State_t;

 uint8_t force_pump_off = 0;    // ˮǿƹرձ־
 uint8_t force_fan_off = 0;     // ǿƹرձ־
AT_State_t at_state = AT_IDLE;
uint32_t at_start_time = 0;

char sim_iccid[ICCID_LENGTH] = {0};  // ʼICCID

// 
uint8_t rxBuff[RX_BUFFER_SIZE];             /* һжϽյ */
uint16_t rxDataSize;                        /* һжϽ */
uint8_t responseBuff[RESPONSE_BUFFER_SIZE]; /* һжϽյ */
uint16_t responseDataSize;                  /* һжϽ */
void Publish_Power_Data(void);

volatile uint8_t need_upload = 0;
void HAL_UARTEx_RxEventCallback(UART_HandleTypeDef *huart, uint16_t size)
{
    if (huart->Instance == USART2)
    {
        rxDataSize = size;
        HAL_UARTEx_ReceiveToIdle_IT(&huart2, rxBuff, 1024);
    }
}

void Inf_4G_Init(void)
{
    /* ʼ2 */
    MX_USART2_UART_Init();

    HAL_UARTEx_ReceiveToIdle_IT(&huart2, rxBuff, 1024);
    Inf_4G_SendAtCmd("AT+CFUN=1\r\n");
    HAL_Delay(2000);
    Inf_4G_SendAtCmd("AT\r\n");

       // ȡICCID
       Get_ICCID();
    // ȡʼźǿ
    Get_Signal_Strength();
}

void Inf_4G_SendAtCmd(uint8_t *atcmd)
{
    // ջ
    memset(responseBuff, 0, sizeof(responseBuff));
    responseDataSize = 0;
    rxDataSize = 0;

    // AT
    HAL_UART_Transmit(&huart2, atcmd, strlen((char *)atcmd), 500);

    // ȴӦ
    uint16_t timeout = 1000; // 1볬ʱ
    while (timeout--)
    {
        if (rxDataSize > 0)
        {
            // Ӧ
            if (strstr((char *)rxBuff, "OK") || strstr((char *)rxBuff, "ERROR"))
            {
                return; // յӦֱӷ
            }
            rxDataSize = 0; // ݴС
        }
        HAL_Delay(1); // 1msʱ
    }
    // ʱ
    printf("ATʱ: %s\n", atcmd);
}

// void Inf_EC800_4GInit(void)
// {
//     // ʼ4Gģ
//     Inf_4G_SendAtCmd("AT+CSQ\r\n");
//     Inf_4G_SendAtCmd("AT+CPIN?\r\n");
//     Inf_4G_SendAtCmd("AT+CEREG?\r\n");
// }

void Inf_EC800_MQTT_Publish(const char *topic, const char *payload)
{
    char atCmd[128];
    snprintf(atCmd, sizeof(atCmd), "AT+QMTPUB=0,0,0,0,\"%s\"\r\n", topic);

    // ATȴ">"ʾ
    Inf_4G_SendAtCmd((uint8_t *)atCmd);

    // Ϣ
    HAL_UART_Transmit(&huart2, (uint8_t *)payload, strlen(payload), 1000);
    HAL_UART_Transmit(&huart2, (uint8_t *)"\x1A", 1, 1000); // Ctrl+Z

    // ȴɵӦ
    HAL_Delay(1000);
}

void Inf_EC800_ReadData(void)
{
    if (rxDataSize > 0)
    {
        printf("յԭʼ: %s\n", rxBuff);

        if (strstr((char *)rxBuff, "+QMTRECV:"))
        {
            char *jsonStart = strchr((char *)rxBuff, '{');
            char *jsonEnd = strrchr((char *)rxBuff, '}');

            if (jsonStart && jsonEnd && jsonEnd > jsonStart)
            {
                int jsonLen = jsonEnd - jsonStart + 1;
                char jsonStr[256] = {0};
                strncpy(jsonStr, jsonStart, jsonLen);

                int value = 0;
                // LED
               
                // ģʽл
                if (sscanf(jsonStr, "{\"X10\":%d}", &value) == 1)
                {

                    switch (value)
                    {
                    case 1: // ģʽ
                        Switch_Mode(MODE_FLUSH);
                        printf("лģʽ\n");
                        rxDataSize = 0;
                        memset(rxBuff, 0, sizeof(rxBuff));
                        break;
                    case 2: // ģʽ
                        Switch_Mode(MODE_IRRIGATION);
                        printf("лģʽ\n");
                        rxDataSize = 0;
                        memset(rxBuff, 0, sizeof(rxBuff));
                        break;
                    case 3: // ֱģʽ
                        Switch_Mode(MODE_DIRECT);
                        printf("лֱģʽ\n");
                        rxDataSize = 0;
                        memset(rxBuff, 0, sizeof(rxBuff));
                        break;
                    default:
                        // printf("Чģʽֵ: %d\n", value);
                        break;
                    }
                }
                 // ޸ˮÿʱ
                 else if (sscanf(jsonStr, "{\"X24\":%d}", &value) == 1)
                 {
                    
                     // 1. ֹͣʱж
                       HAL_TIM_Base_Stop_IT(&htim2);  // ʹõTIM2ʵ޸
                     switch (current_mode)
                     {
                         case MODE_IRRIGATION:
                             HIGH_LEVEL_PUMP_ON_TIME = (uint32_t)value;
                            break;
                             
                         case MODE_FLUSH:
                             FLUSH_HIGH_PUMP_ON_TIME = (uint32_t)value;
                             break;
                             
                         case MODE_DIRECT:
                            DIRECT_HIGH_PUMP_ON_TIME = (uint32_t)value;
                            
                             break;
                     }
                     Time_Save();  // ޸ĺʱ
                      // 3. ر豸
                    Control_WaterPump(0);
                    Control_Fan1(0);
                    Control_Fan2(0);

                    // 4. ȫмʱ
                    pump_timer = 0;
                    fan_timer = 0;
                  // timer_count = 0;  // ܵļʱҲҪ
    
                    // 5. ʱֵ
                    __HAL_TIM_SET_COUNTER(&htim2, 0);
                     // ˮüʱ
                     Restart_Current_Mode();  // ǰģʽ

                     HAL_TIM_Base_Start_IT(&htim2);
                  
                 }
                 // ޸ˮֹͣʱ
                else if (sscanf(jsonStr, "{\"X25\":%d}", &value) == 1)
                {
                    // 1. ֹͣʱж
                    HAL_TIM_Base_Stop_IT(&htim2);  // ʹõTIM2ʵ޸
                    switch (current_mode)
                    {
                        case MODE_IRRIGATION:
                            HIGH_LEVEL_PUMP_OFF_TIME = value;
                           // printf("ģʽˮֹͣʱ޸Ϊ%d\n", value);
                            break;
                            
                        case MODE_FLUSH:
                            FLUSH_HIGH_PUMP_OFF_TIME = value;
                           // printf("ģʽˮֹͣʱ޸Ϊ%d\n", value);
                            break;
                            
                        case MODE_DIRECT:
                            DIRECT_HIGH_PUMP_OFF_TIME = value;
                          
                           // printf("ֱģʽˮֹͣʱ޸Ϊ%d\n", value);
                            break;
                    }
                    Time_Save();  // ޸ĺʱ
                     // 3. ر豸
                     Control_WaterPump(0);
                     Control_Fan1(0);
                     Control_Fan2(0);
 
                     // 4. ȫмʱ
                     pump_timer = 0;
                     fan_timer = 0;
                    // timer_count = 0;  // ܵļʱҲҪ
     
                     // 5. ʱֵ
                     __HAL_TIM_SET_COUNTER(&htim2, 0);
                      // ˮüʱ
                      Restart_Current_Mode();  // ǰģʽ
 
                      HAL_TIM_Base_Start_IT(&htim2);
                }
                else if (sscanf(jsonStr, "{\"X54\":%d}", &value) == 1)
                {
                    // 1. ֹͣʱж
                    HAL_TIM_Base_Stop_IT(&htim2);  // ʹõTIM2ʵ޸
                    switch (current_mode)
                    {
                        case MODE_IRRIGATION:
                            HIGH_LEVEL_FAN_ON_TIME = value;
                            break;
                            
                        case MODE_FLUSH:
                            FLUSH_HIGH_FAN_ON_TIME = value;
                            break;
                            
                        case MODE_DIRECT:
                            DIRECT_HIGH_FAN_ON_TIME = value;
                            break;
                    }
                    Time_Save();  // ޸ĺʱ
                    // 3. ر豸
                    Control_WaterPump(0);
                    Control_Fan1(0);
                    Control_Fan2(0);

                    // 4. ȫмʱ
                    pump_timer = 0;
                    fan_timer = 0;
                   // timer_count = 0;  // ܵļʱҲҪ
    
                    // 5. ʱֵ
                    __HAL_TIM_SET_COUNTER(&htim2, 0);
                     // ˮüʱ
                     Restart_Current_Mode();  // ǰģʽ

                     HAL_TIM_Base_Start_IT(&htim2);
                }
                // ޸ĸҺλֹͣʱ
                else if (sscanf(jsonStr, "{\"X55\":%d}", &value) == 1)
                {
                   switch (current_mode)
                    {
                        case MODE_IRRIGATION:
                            HIGH_LEVEL_FAN_OFF_TIME = value;
                            break;

                        case MODE_FLUSH:
                            FLUSH_HIGH_FAN_OFF_TIME = value;
                            break;

                        case MODE_DIRECT:
                            DIRECT_HIGH_FAN_OFF_TIME = value;
                            break;
                    }
                    Time_Save();  // ޸ĺʱ
                    // 3. ر豸
                    Control_WaterPump(0);
                    Control_Fan1(0);
                    Control_Fan2(0);

                    // 4. ȫмʱ
                    pump_timer = 0;
                    fan_timer = 0;
                  //  timer_count = 0;  // ܵļʱҲҪ
    
                    // 5. ʱֵ
                    __HAL_TIM_SET_COUNTER(&htim2, 0);
                     // ˮüʱ
                     Restart_Current_Mode();  // ǰģʽ

                     HAL_TIM_Base_Start_IT(&htim2);
                }

                // ޸ĵҺλʱ
            else if (sscanf(jsonStr, "{\"X56\":%d}", &value) == 1)
            {
                // 1. ֹͣʱж
                HAL_TIM_Base_Stop_IT(&htim2);  // ʹõTIM2ʵ޸
                switch (current_mode)
                {
                    case MODE_IRRIGATION:
                        LOW_LEVEL_FAN_ON_TIME = value;
                        break;
                        
                    case MODE_FLUSH:
                        FLUSH_LOW_FAN_ON_TIME = value;
                        break;
                        
                    case MODE_DIRECT:
                        DIRECT_LOW_FAN_ON_TIME = value;
                        break;
                }
                Time_Save();  // ޸ĺʱ
                 // 3. ر豸
                Control_WaterPump(0);
                 Control_Fan1(0);
                 Control_Fan2(0);

                 // 4. ȫмʱ
                 pump_timer = 0;
                fan_timer = 0;
                // timer_count = 0;  // ܵļʱҲҪ
 
                 // 5. ʱֵ
                 __HAL_TIM_SET_COUNTER(&htim2, 0);
                  // ˮüʱ
                  Restart_Current_Mode();  // ǰģʽ

                  HAL_TIM_Base_Start_IT(&htim2);
            }
            // ޸ĵҺλֹͣʱ
            else if (sscanf(jsonStr, "{\"X57\":%d}", &value) == 1)
            {
                // 1. ֹͣʱж
                HAL_TIM_Base_Stop_IT(&htim2);  // ʹõTIM2ʵ޸
                switch (current_mode)
                {
                    case MODE_IRRIGATION:
                       LOW_LEVEL_FAN_OFF_TIME = value;
                        break;
                        
                    case MODE_FLUSH:
                        FLUSH_LOW_FAN_OFF_TIME = value;
                        break;
                       
                    case MODE_DIRECT:
                        DIRECT_LOW_FAN_OFF_TIME = value;
                        break;
                }
                Time_Save();  // ޸ĺʱ
                 // 3. ر豸
                 Control_WaterPump(0);
                 Control_Fan1(0);
                 Control_Fan2(0);

                 // 4. ȫмʱ
                 pump_timer = 0;
                 fan_timer = 0;
                // timer_count = 0;  // ܵļʱҲҪ
 
                 // 5. ʱֵ
                 __HAL_TIM_SET_COUNTER(&htim2, 0);
                  // ˮüʱ
                  Restart_Current_Mode();  // ǰģʽ

                  HAL_TIM_Base_Start_IT(&htim2);
            }           
                else if (sscanf(jsonStr, "{\"X15\":%d}", &value) == 1)
                {
                    if (value == 1)
                    {
                        ozone_running = 1; // 
                        ozone_timer = 0;   // üʱ
                        Ozone_Control(1);  // 
                      //  printf("\n");
                    }
                    else if (value == 0)
                    {
                        ozone_running = 0; // ֹͣ
                        ozone_timer = 0;   // üʱ
                        Ozone_Control(0);  // رճ
                     //   printf("ֹͣ\n");
                    }
                }
                // ʱ
                else if (sscanf(jsonStr, "{\"X20\":%d}", &value) == 1)
                {
                    OZONE_ON_TIME = value;
                    ozone_timer = 0; // üʱ
                    Save_Ozone_Time_To_EEPROM(OZONE_ON_TIME, OZONE_OFF_TIME); 
                                     // printf("óʱ: %d\n", value);
                }
                // رʱ
                else if (sscanf(jsonStr, "{\"X21\":%d}", &value) == 1)
                {
                    OZONE_OFF_TIME = value;
                    ozone_timer = 0; // üʱ
                    Save_Ozone_Time_To_EEPROM(OZONE_ON_TIME, OZONE_OFF_TIME); // 浽EEPROM
                                     // printf("óرʱ: %d\n", value);
                }

              

                // ˮÿ
                else if (sscanf(jsonStr, "{\"X12\":%d}", &value) == 1)
                {
                    if (value == CMD_ON || value == CMD_OFF)
                    {
                        force_pump_off = (value == CMD_OFF);  // ǿƹرձ־
                        // ǿȷǿƹرձ־
                        if (value == CMD_ON) {
                            force_pump_off = 0;
                            Control_WaterPump(1);
                            printf("ˮǿƿ\n");
                        } else {
                            force_pump_off = 1;
                            Control_WaterPump(0);
                            printf("ˮǿƹر\n");
                        }
                        rxDataSize = 0;
                        memset(rxBuff, 0, sizeof(rxBuff));
                    }
                }
                // 1
                else if (sscanf(jsonStr, "{\"X13\":%d}", &value) == 1)
                {
                    if (value == CMD_ON || value == CMD_OFF)
                    {
                        force_fan_off = (value == CMD_OFF);   // ǿƹرձ־
                        // ǿȷǿƹرձ־
                          if (value == CMD_ON) {
                              force_fan_off = 0;
                              Control_Fan1(1);
                              printf("1ǿƿ\n");
                          } else {
                              force_fan_off = 1;
                              Control_Fan1(0);
                              printf("1ǿƹر\n");
                          }
                        //   printf("1: %s\n", value ? "" : "ر");
                    }
                }
                // 2
                else if (sscanf(jsonStr, "{\"X14\":%d}", &value) == 1)
                {
                    if (value == CMD_ON || value == CMD_OFF)
                    {
                     // 2ĿҲҪǿƹرձ־
                     if (value == CMD_ON) {
                         force_fan_off = 0;  // ǿƹرձ־
                         Control_Fan2(1);
                         printf("2ǿƿ\n");
                     } else {
                         force_fan_off = 1;  // ǿƹرձ־
                         Control_Fan2(0);
                         printf("2ǿƹر\n");
                     }
                    }
                }
                // Ĥ (ʹ X16 Ϊָ)
                else if (sscanf(jsonStr, "{\"X18\":%d}", &value) == 1)
                {
                    if (value == CMD_ON || value == CMD_OFF)
                    {
                        Control_Heater((uint8_t)value);
                        // printf("Ĥ: %s\n", value ? "" : "ر");
                    }
                }
                else if (sscanf(jsonStr, "{\"X22\":%d}", &value) == 1)
                {
                    temp_lower_limit = (float)value;
                    // printf("¶Ϊ: %.1f\n", temp_lower_limit);
                }
                // ¶
                else if (sscanf(jsonStr, "{\"X23\":%d}", &value) == 1)
                {
                    temp_upper_limit = (float)value;
                    // printf("¶Ϊ: %.1f\n", temp_upper_limit);
                }
                // ܿ
                else if (sscanf(jsonStr, "{\"X59\":%d}", &value) == 1)
                {
                    if (value == CMD_ON || value == CMD_OFF)
                    {
                        Control_All_Devices(value); // ܿؿƺ
                    }
                }

                // Ƴ׿أX32
                else if (sscanf(jsonStr, "{\"X49\":%d}", &value) == 1)
                {
                    if (value == 1)
                    {
                        // 
                        
                        phosphorus_timer = 0;
                        polarity_state = !polarity_state;
                        Control_Phosphorus_Polarity();  // óʼ
                        Phosphorus_Control_Update();
                    }
                    else
                    {
                        Control_Phosphorus(0);          // رճ
                    }
                }
                else if (sscanf(jsonStr, "{\"X51\":%d}", &value) == 1)
                {
                    PHOSPHORUS_RUN_TIME=value;
                                                   //  printf("óʱΪ%d\n", value);
                }
                // óֹͣʱ䣨X34
                else if (sscanf(jsonStr, "{\"X52\":%d}", &value) == 1)
                {
                    PHOSPHORUS_STOP_TIME=value;
                                                    //  printf("óֹͣʱΪ%d\n", value);
                }
                  // Զ̿ƴ
                  if (sscanf(jsonStr, "{\"X53\":%d}", &value) == 1)
                  {
                      if (value == 1)  // 
                      {
                        Control_Dredge(1);
                          
                      }
                      else if (value == 0)  // ر
                      {
                        Control_Dredge(0);
                         
                      }
                  }
                // ģʽרÿưť
            else if (sscanf(jsonStr, "{\"X58\":%d}", &value) == 1)
            {
                if (value == 1)
                {
                    // ģʽ
                    Switch_Mode(MODE_SPECIAL);
                   // printf("ģʽ\n");
                }
                else if (value == 0)
                {
                    Switch_Mode(MODE_DIRECT);
                    // ֹͣģʽлֱģʽ
                    
                    printf("ֹͣģʽлֱģʽ\n");
                }
                rxDataSize = 0;
                memset(rxBuff, 0, sizeof(rxBuff));
            }
            }
        }
        if (parameters_changed)
        {
          //  Restart_Current_Mode();
          //  parameters_changed = 0;  // ñ־
        }
        rxDataSize = 0;
        memset(rxBuff, 0, sizeof(rxBuff));
    }
}

// MQTTʼ
void Inf_EC800_MQTT_Init(void)
{
    char mqtt_cmd[128];  // ڴ洢ATĻ
    
    // ȶϿܴڵ
    Inf_4G_SendAtCmd((uint8_t *)"AT+QMTDISC=0\r\n");
    HAL_Delay(300);
    Inf_4G_SendAtCmd((uint8_t *)"AT+QMTCLOSE=0\r\n");
    HAL_Delay(300);

    // ýģʽ
    Inf_4G_SendAtCmd((uint8_t *)"AT+QMTCFG=\"recv/mode\",0,0,0\r\n");
    HAL_Delay(100);

    // keepaliveʱΪ60
    Inf_4G_SendAtCmd((uint8_t *)"AT+QMTCFG=\"keepalive\",0,60\r\n");
    HAL_Delay(100);

    // MQTT
    sprintf(mqtt_cmd, "AT+QMTOPEN=0,\"%s\",%s\r\n", MQTT_SERVER_IP, MQTT_SERVER_PORT);
    Inf_4G_SendAtCmd((uint8_t *)mqtt_cmd);
    HAL_Delay(2000);

    // MQTTʹΨһĿͻID
    sprintf(mqtt_cmd, "AT+QMTCONN=0,\"%s\",\"%s\",\"%s\"\r\n", 
            MQTT_CLIENT_ID, MQTT_USERNAME, MQTT_PASSWORD);
    Inf_4G_SendAtCmd((uint8_t *)mqtt_cmd);
    HAL_Delay(1000);

    // 
    sprintf(mqtt_cmd, "AT+QMTSUB=0,1,\"%s\",1\r\n", MQTT_TOPIC);
    Inf_4G_SendAtCmd((uint8_t *)mqtt_cmd);
    HAL_Delay(1000);
}
// ϴ
//  ϴ
//  建
#define TX_BUFFER_SIZE 256
uint8_t txBuff[TX_BUFFER_SIZE]; // ͻ

// MQTTݷͺ
// MQTTݺ
void Inf_EC800_SendMqttData(uint16_t id, uint8_t data[], uint16_t dataLen)
{
    memset(txBuff, 0, sizeof(txBuff));

    sprintf((char *)txBuff, "AT+QMTPUB=0,0,0,0,\"%s\"\r\n", MQTT_PUB_TOPIC);
    Inf_4G_SendAtCmd(txBuff);

    HAL_UART_Transmit(&huart2, data, dataLen, 1000);
    HAL_UART_Transmit(&huart2, (uint8_t *)"\x1A", 1, 1000);

    HAL_Delay(100);
}

// ϴ
void Upload_Device_Data(void)
{
    uint8_t payload[256];
    uint16_t dataLen;
     
    Update_All_Status(); // ״̬ӡ
    Check_Power_Source();
    uint8_t power_type = Get_Power_Type();
    Print_Temperature(data1);
    Get_Signal_Strength();
    // 
  
    // ȡǰģʽˮʱ
    uint32_t current_pump_on = 0;
    uint32_t current_pump_off = 0;
    // ȡǰеʱ
    //  ӸҺλʱ
    uint32_t current_high_fan_on = 0;
    uint32_t current_high_fan_off = 0;
    // ӵҺλʱ
    uint32_t current_low_fan_on = 0;
    uint32_t current_low_fan_off = 0;

   
    switch (current_mode)
    {
    case MODE_IRRIGATION:
        current_pump_on = HIGH_LEVEL_PUMP_ON_TIME;
        current_pump_off = HIGH_LEVEL_PUMP_OFF_TIME;
        current_high_fan_on = HIGH_LEVEL_FAN_ON_TIME;
        current_high_fan_off = HIGH_LEVEL_FAN_OFF_TIME;
        current_low_fan_on = LOW_LEVEL_FAN_ON_TIME; // ģʽҺλʱ
        current_low_fan_off = LOW_LEVEL_FAN_OFF_TIME;
        break;

    case MODE_FLUSH:
        current_pump_on = FLUSH_HIGH_PUMP_ON_TIME;
        current_pump_off = FLUSH_HIGH_PUMP_OFF_TIME;
        current_high_fan_on = FLUSH_HIGH_FAN_ON_TIME;
        current_high_fan_off = FLUSH_HIGH_FAN_OFF_TIME;
        current_low_fan_on = FLUSH_LOW_FAN_ON_TIME; // ģʽҺλʱ
        current_low_fan_off = FLUSH_LOW_FAN_OFF_TIME;
        break;

    case MODE_DIRECT:
        current_pump_on = DIRECT_HIGH_PUMP_ON_TIME;
        current_pump_off = DIRECT_HIGH_PUMP_OFF_TIME;
        current_high_fan_on = DIRECT_HIGH_FAN_ON_TIME;
        current_high_fan_off = DIRECT_HIGH_FAN_OFF_TIME;
        current_low_fan_on = DIRECT_LOW_FAN_ON_TIME; // ֱģʽҺλʱ
        current_low_fan_off = DIRECT_LOW_FAN_OFF_TIME;
        break;
        case MODE_SPECIAL:
        // ãֱģʽͬ
        current_high_fan_on = DIRECT_HIGH_FAN_ON_TIME;    // 40
        current_high_fan_off = DIRECT_HIGH_FAN_OFF_TIME;  // 2
        current_low_fan_on = DIRECT_LOW_FAN_ON_TIME;      // 10
        current_low_fan_off = DIRECT_LOW_FAN_OFF_TIME;    // 20

        // ģʽ׶ˮò
        switch(special_phase) {
            case SPECIAL_INITIAL_STOP:
                printf("ģʽʼ׶ - 24Сʱֹͣ\n");
                current_pump_on = 0;
                current_pump_off = SPECIAL_INITIAL_STOP_TIME;  // 1440
                break;
                
            case SPECIAL_FIRST_PHASE:
                printf("ģʽһ׶ - 6Сʱѭ\n");
                current_pump_on = SPECIAL_PUMP_RUN_TIME;      // 1
                current_pump_off = SPECIAL_FIRST_STOP_TIME;   // 359
                break;
                
            case SPECIAL_SECOND_PHASE:
                printf("ģʽڶ׶ - 4Сʱѭ\n");
                current_pump_on = SPECIAL_PUMP_RUN_TIME;      // 1
                current_pump_off = SPECIAL_SECOND_STOP_TIME;  // 239
                break;
                
            default:
                printf("Чģʽ׶\n");
                break;
        }
        break;
    }
    
    // ӡǰֵ
   // printf("\nǰֵ:\n");
  //  printf("ģʽ: %d\n", current_mode);
  //  printf("ˮÿʱ: %d\n", current_pump_on);
  //  printf("ˮùرʱ: %d\n", current_pump_off);
 //   printf("λʱ: %d\n", current_high_fan_on);
 //   printf("λرʱ: %d\n", current_high_fan_off);
 //   printf("λʱ: %d\n", current_low_fan_on);
  //  printf("λرʱ: %d\n", current_low_fan_off);

    // JSONݣӵbase_energy
    dataLen = sprintf((char *)payload,
                      "{"
              
                      "\"X4\":%d,"    // źǿ                  X4
                      "\"X10\":%d,"   // ϴǰģʽ             X10
                      "\"X12\":%d,"   // ˮ                     X12
                      "\"X13\":%d,"   // 1  X13
                      "\"X14\":%d,"   // 2   X14
                      "\"X15\":%d,"   // ״̬   X15
                      "\"X18\":%d,"   // Ĥ   X18
                      "\"X20\":%d,"   // ϴʱ    X20
                      "\"X21\":%d,"   // ϴرʱ     X21
                      "\"X5\":%.2f,"  // ¶             X5
                      "\"X22\":%.1f," // ¶   X22
                      "\"X23\":%.1f," // ¶   X23
                      "\"X24\":%d,"   // ǰˮÿʱ      X24
                      "\"X25\":%d,"   // ǰˮùرʱ     X25
                      "\"X35\":%d,"   //ǰˮõĹ     X35
                      "\"X37\":%d,"   //ǰ1Ĺ     X37
                      "\"X38\":%d,"   //ǰˮõĹ     X38
                      "\"X44\":%d,"   // ǰˮùرʱ     X44
                      "\"X46\":%d,"   // е         X46
                      "\"X47\":%d,"   //              X47
                      "\"X49\":%d,"   // ׿         X49
                      "\"X50\":%d,"   // ״̬            X50
                      "\"X51\":%d,"   // ʱ            X51
                      "\"X52\":%d,"   // ֹͣʱ            X52
                      "\"X53\":%d,"   //             X53
                      "\"X54\":%d,"   // Һλʱ    X54
                      "\"X55\":%d,"   // Һλرʱ    X55
                      "\"X56\":%d,"   // Һλʱ
                      "\"X57\":%d,"   // Һλرʱ
                      "\"X58\":%d,"   // Һλرʱ
                      "\"X59\":%d,"   // ϵͳ״̬
                      "\"X300\":%.6f," // ӵֶ     X300
                      "\"X001\":\"%s\"" // ICCIDֶ
                      "}",
                     // device_status[11],       // ˮ                   X1
                      gsm_signal_strength,     // źǿ              X4
                      current_mode,            // ϴǰģʽ             X10
                      device_status[1],        // ˮ                    X12
                      device_status[2],        // 1                   X13
                      device_status[3],        // 2                   X14
                      ozone_running,           // ״̬             X15
                      device_status[7],        // Ĥ״̬               X18
                      OZONE_ON_TIME,           // ǰʱ          X20
                      OZONE_OFF_TIME,          // ǰرʱ          X21
                      temperature,             // ¶ֵӵJSON      X5
                      temp_lower_limit,        // ¶                 X22
                      temp_upper_limit,        // ¶                 X23
                      current_pump_on,         // ֻϴˮʱ            X24
                      current_pump_off,        // ֻϴˮʱ            X25
                      device_fault.pump_fault,  // ӹ״̬ 0: 1:  X35
                      device_fault.fan1_fault,  //1Ĺ              X37
                      device_fault.fan2_fault,  //2Ĺ              X38
                      device_status[5],        // Һλˮ״̬            X44
                      device_status[8],        // е                 X46
                      power_type,                  // е״̬           X47
                      Dephosphorization_state, // ׿״̬        X49
                      device_status[9],        // ״̬                 X50
                      PHOSPHORUS_RUN_TIME,     // ǰõʱ
                      PHOSPHORUS_STOP_TIME,    // ǰõֹͣʱ
                      device_status[10],       // ״̬                 X53
                      current_high_fan_on,     // X54
                      current_high_fan_off,    // X55
                      current_low_fan_on,      // X56
                      current_low_fan_off,     // X57
                      (current_mode == MODE_SPECIAL) ? 1 : 0,  // ģʽ׶Σ x58
                      device_status[11],       // ϵͳ״̬                 X59
                      base_energy,            // ֵӵJSON      X300
                      sim_iccid         // ICCIDֵ
    );

    // 
    Inf_EC800_SendMqttData(0, payload, dataLen);
    // ӵԴӡ
  //  printf("ݷ - ͵ˮֵ%d\r\n", device_status[11]);
    
    // ͺ
   // pump_flow = 0;
  //  device_status[11] = 0;
  //  flow_to_upload = 0;

}

// źǿȱ
int8_t gsm_signal_strength = 0;

// ȡźǿȺ
void Get_Signal_Strength(void)
{
    memset(rxBuff, 0, sizeof(rxBuff));
    rxDataSize = 0;

    Inf_4G_SendAtCmd("AT+CSQ\r\n");

    // źǿ
    char *ptr = strstr((char *)rxBuff, "+CSQ:");
    if (ptr)
    {
        int csq;
        if (sscanf(ptr, "+CSQ: %d", &csq) == 1)
        {
            gsm_signal_strength = csq;
        }
    }
}
// ... existing code ...



// ״̬
// ... existing code ...

// ȫֱ
static uint32_t last_check_time = 0;
static uint8_t reconnect_count = 0;
#define MAX_RECONNECT_ATTEMPTS 3
#define CHECK_INTERVAL 60000  // 60һ

// ״̬
void Check_4G_Connection(void)
{
    uint32_t current_time = HAL_GetTick();
    
    // ÿ60һ״̬
    if(current_time - last_check_time >= CHECK_INTERVAL)
    {
        last_check_time = current_time;
        
        // ջ
        memset(rxBuff, 0, sizeof(rxBuff));
        rxDataSize = 0;
        
        // MQTT״̬
        Inf_4G_SendAtCmd("AT+QMTCONN?\r\n");
        HAL_Delay(100);
        
        // ֻеMQTTδʱŽ
        if(!strstr((char *)rxBuff, "+QMTCONN: 0,3"))
        {
          //  printf("MQTTӶϿ...\n");
            
            if(reconnect_count < MAX_RECONNECT_ATTEMPTS)
            {
                reconnect_count++;
                Inf_EC800_MQTT_Init();  // ֻ³ʼMQTT
              //  printf("MQTT %d/%d\n", reconnect_count, MAX_RECONNECT_ATTEMPTS);
            }
            else
            {
             //   printf("MQTTʧܴ࣬״̬\n");
            }
        }
        else
        {
            // 
            reconnect_count = 0;
        }
    }
}



// ӻȡICCIDĺ
void Get_ICCID(void)
{
    memset(rxBuff, 0, sizeof(rxBuff));
    rxDataSize = 0;

    Inf_4G_SendAtCmd("AT+QCCID\r\n");
    HAL_Delay(100);

    // ICCID
    char *ptr = strstr((char *)rxBuff, "+QCCID:");
    if (ptr)
    {
        // "+QCCID: "ֱӻȡICCID
        ptr += 8;  // "+QCCID: "
        // ȥܵĿոͻз
        while (*ptr == ' ') ptr++;
        // ICCIDsim_iccid
        strncpy(sim_iccid, ptr, ICCID_LENGTH - 1);
        sim_iccid[ICCID_LENGTH - 1] = '\0';  // ȷַ
    }
}
